SystemOrganization addCategory: #'DAO-TP-Changes'!

Object subclass: #SistemaDeCambios
	instanceVariableNames: 'unidadesDeTrabajoCerradas unidadDeTrabajoActiva'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-TP-Changes'!

!SistemaDeCambios methodsFor: 'as yet unclassified' stamp: 'maxi 9/9/2013 20:19'!
cerrarUnidadDeTrabajo
	self unidadActiva cerrar.
	^self! !

!SistemaDeCambios methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 9/16/2013 22:34'!
initialize 
	unidadesDeTrabajoCerradas := OrderedCollection new.
	unidadDeTrabajoActiva := UnidadDeTrabajoReal new.! !

!SistemaDeCambios methodsFor: 'as yet unclassified' stamp: 'maxi 9/9/2013 20:21'!
registrarCambio: unCambio 
	^self unidadActiva registrarCambio: unCambio.! !

!SistemaDeCambios methodsFor: 'as yet unclassified' stamp: 'maxi 9/16/2013 21:41'!
unidadActiva
	"devuelve la unidad de trabajo activa"
	^unidadDeTrabajoActiva.
	! !

!SistemaDeCambios methodsFor: 'as yet unclassified' stamp: 'maxi 9/9/2013 20:43'!
unidadesDeTrabajo
	|todasLasUnidadesDeTrabajo|
	todasLasUnidadesDeTrabajo := unidadesDeTrabajoCerradas asSet.
	todasLasUnidadesDeTrabajo add: unidadDeTrabajoActiva.
	^todasLasUnidadesDeTrabajo.! !

Object subclass: #UnidadDeTrabajo
	instanceVariableNames: 'cambios cerrada'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-TP-Changes'!

UnidadDeTrabajo class
	instanceVariableNames: 'unidadActiva unidadesCerradas'!

UnidadDeTrabajo class
	instanceVariableNames: 'unidadActiva unidadesCerradas'!

!UnidadDeTrabajo class methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 9/16/2013 22:44'!
noSePuedeRegistrarCambios
	^'No se puede registrar cambios en esta unidad de trabajo.'.! !

!UnidadDeTrabajo class methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 9/16/2013 23:30'!
registrarCambio: unCambio
	| nuevaUnidadActiva |
	[ unidadActiva registrarCambio: unCambio]
	on: Error
	do: [ nuevaUnidadActiva := UnidadDeTrabajoReal newWith: unidadActiva.
		unidadesCerradas add: unidadActiva.
		unidadActiva := nuevaUnidadActiva.
		unidadActiva registrarCambio: unCambio ].
	^self
! !

!UnidadDeTrabajo methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 9/16/2013 22:44'!
cerrar
	cerrada := true.! !

!UnidadDeTrabajo methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 9/16/2013 22:44'!
estaCerrada
	^cerrada.! !

!UnidadDeTrabajo methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 9/16/2013 22:44'!
initialize
	cambios := OrderedCollection new.
	cerrada := false.
	^self! !

!UnidadDeTrabajo methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 9/16/2013 22:44'!
registrarCambio: unCambio
	self estaCerrada ifTrue: [ Error signal: self class noSePuedeRegistrarCambios]. 
	cambios add: unCambio.
	^self.! !

!UnidadDeTrabajo methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 9/16/2013 22:44'!
todosLosCambios
	^cambios.! !

UnidadDeTrabajo subclass: #UnidadDeTrabajoInicial
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-TP-Changes'!

UnidadDeTrabajo subclass: #UnidadDeTrabajoReal
	instanceVariableNames: 'padre'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-TP-Changes'!

!UnidadDeTrabajoReal class methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 9/16/2013 22:38'!
newWith: unaUnidadDeTrabajo
	^self new initializeWith: unaUnidadDeTrabajo.! !

!UnidadDeTrabajoReal methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 9/16/2013 22:39'!
initializeWith: unaUnidadDeTrabajo
	padre := unaUnidadDeTrabajo.
	^self.
	! !

!UnidadDeTrabajoReal methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 9/16/2013 22:53'!
padre
	^ padre! !

TestCase subclass: #ChangesTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-TP-Changes'!

!ChangesTest methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 9/16/2013 22:37'!
algunaUnidadDeTrabajo
	^UnidadDeTrabajoInicial  new.! !

!ChangesTest methodsFor: '01UnidadDeTrabajoTest' stamp: 'SebastianGarbi 9/16/2013 22:55'!
test001LaUnidadDeTrabajoInicialNoSabeResponderElMensajePadre
	| unaUnidadDeTrabajoInicial |
	unaUnidadDeTrabajoInicial := UnidadDeTrabajoInicial new.
	self should: [ unaUnidadDeTrabajoInicial padre ]
			raise:  MessageNotUnderstood 
			withExceptionDo: [ :aMessageNotUnderstood  | aMessageNotUnderstood messageText = '#padre' ]
! !

!ChangesTest methodsFor: '01UnidadDeTrabajoTest' stamp: 'maxi 9/23/2013 19:07'!
test002UnaUnidadDeTrabajoSeCreaSinCambiosYAbierta
	| unaUnidadDeTrabajo |
	unaUnidadDeTrabajo := UnidadDeTrabajoReal newWith: self algunaUnidadDeTrabajo.
	self assert: unaUnidadDeTrabajo todosLosCambios isEmpty.
	self deny: unaUnidadDeTrabajo estaCerrada.
	
	unaUnidadDeTrabajo := UnidadDeTrabajoInicial new.
	self assert: unaUnidadDeTrabajo todosLosCambios isEmpty.
	self deny: unaUnidadDeTrabajo estaCerrada.! !

!ChangesTest methodsFor: '01UnidadDeTrabajoTest' stamp: 'maxi 9/23/2013 19:08'!
test003UnaUnidadDeTrabajoQueRegistraUnCambioNoEstaVacia
	
	| unaUnidadDeTrabajo |
	unaUnidadDeTrabajo := UnidadDeTrabajoReal new.
	unaUnidadDeTrabajo registrarCambio: self unCambio.
	self deny: unaUnidadDeTrabajo todosLosCambios isEmpty.! !

!ChangesTest methodsFor: '01UnidadDeTrabajoTest' stamp: 'maxi 9/23/2013 19:08'!
test004RegistrarUnCambioEnUnidadCerradaLanzaUnaExcepcion
	
	| unaUnidadDeTrabajo |
	
	unaUnidadDeTrabajo := UnidadDeTrabajoReal new.
	unaUnidadDeTrabajo cerrar.

	self should: [ unaUnidadDeTrabajo registrarCambio: self unCambio ] raise: Error withExceptionDo:  [ :anError | anError messageText  = UnidadDeTrabajoReal noSePuedeRegistrarCambios.
	self assert: unaUnidadDeTrabajo todosLosCambios isEmpty ].

	! !

!ChangesTest methodsFor: '02SistemaDeCambios' stamp: 'maxi 9/23/2013 19:08'!
test005UnSistemaDeCambiosSeInicializaConUnaUnidadDeTrabajoActivaVacia
	
	| unSistemaDeCambios |
	unSistemaDeCambios := SistemaDeCambios new.
	self assert: unSistemaDeCambios unidadesDeTrabajo size = 1.
	self assert: unSistemaDeCambios unidadActiva todosLosCambios size = 0.! !

!ChangesTest methodsFor: '02SistemaDeCambios' stamp: 'maxi 9/23/2013 19:09'!
test006ElSistemaRegistraLosCambiosEnLaUnidadActiva
	
	| unSistemaDeCambios unaUnidadDeTrabajo |
	unSistemaDeCambios := SistemaDeCambios new.
	unSistemaDeCambios registrarCambio: self unCambio.
	unaUnidadDeTrabajo := unSistemaDeCambios unidadActiva. 
	self assert: unaUnidadDeTrabajo todosLosCambios size = 1.! !

!ChangesTest methodsFor: '01UnidadDeTrabajoTest' stamp: 'SebastianGarbi 9/16/2013 22:54'!
test007UnaunidadDeTrabajoRealConoceASuPadre
	| unaUnidadDeTrabajoPadre unaUnidadDeTrabajo |
	unaUnidadDeTrabajoPadre := self algunaUnidadDeTrabajo.
	unaUnidadDeTrabajo  := UnidadDeTrabajoReal newWith: unaUnidadDeTrabajoPadre.
	self assert: (unaUnidadDeTrabajo padre = unaUnidadDeTrabajoPadre).! !

!ChangesTest methodsFor: 'as yet unclassified' stamp: 'maxi 9/9/2013 21:03'!
unCambio
	^1.! !
